> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.brevo.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.brevo.com/_mcp/server.

# Create events in batch

POST https://api.brevo.com/v3/events/batch
Content-Type: application/json

Create multiple events to track contacts' interactions in a single request.

Reference: https://developers.brevo.com/reference/create-batch-events

## Authentication

- `api-key` header (required) — The API key should be passed in the request headers as `api-key` for authentication.

## Request

### Body (application/json)

This endpoint expects an object.

- `events` (list of object, required)
  - `event_name` (string, required) — The name of the event that occurred. This is how you will find your event in Brevo. Limited to 255 characters, alphanumerical characters and - _ only.
  - `identifiers` (object, required) — Identifies the contact associated with the event. At least one identifier is required.
    - `contact_id` (long, optional) — Internal unique contact ID. When present, this takes priority over all other identifiers for event attribution and contact resolution.
    - `email_id` (string, optional) — Email Id associated with the event
    - `ext_id` (string, optional) — ext_id associated with the event
    - `landline_number_id` (string, optional) — landline_number associated with the event
    - `phone_id` (string, optional) — SMS associated with the event
    - `whatsapp_id` (string, optional) — whatsapp associated with the event
  - `contact_properties` (map from string to string or integer, optional) — Properties defining the state of the contact associated to this event. Useful to update contact attributes defined in your contacts database while passing the event. For example: **"FIRSTNAME": "Jane" , "AGE": 37**
  - `event_date` (string, optional) — Timestamp of when the event occurred (e.g. "2024-01-24T17:39:57+01:00"). If no value is passed, the timestamp of the event creation is used.
  - `event_properties` (map from string to string or integer or map from string to any or list of any, optional) — Properties of the event. Top level properties and nested properties can be used to better segment contacts and personalise workflow conditions. The following field type are supported: string, number, boolean (true/false), date (Timestamp e.g. "2024-01-24T17:39:57+01:00"). Keys are limited to 255 characters, alphanumerical characters and - _ only. Size is limited to 50Kb.
  - `object` (object, optional) — Identifiers of the object record associated with this event. Ignored if the object type or identifier for this record does not exist on the account.
    - `identifiers` (object, optional) — Identifiers for the object.
      - `ext_id` (string, optional) — External object ID
      - `id` (string, optional) — Internal object ID
    - `type` (string, optional) — Type of object (e.g., subscription, vehicle, etc.)

## Response

### 202

Batch accepted - all events have been added to the processing queue

- `message` (string, required) — Confirmation message indicating the batch was accepted
- `count` (integer, required) — Number of events queued for processing

### 207

Partial success - some events were accepted and some failed

- `status` (string, required) — Status of the batch request
- `total_events` (integer, required) — Total number of events submitted in the batch
- `successful_events` (integer, required) — Number of events that were successfully processed
- `failed_events` (integer, required) — Number of events that failed to be processed
- `errors` (list of object, required) — List of errors for the failed events
  - `eventIndex` (list of integer, optional) — Index positions (0-based) of the events that caused the error
  - `message` (string, optional) — Description of the error

## Errors

### 400 Bad Request Error

Bad request - all events in the batch failed validation

- `status` (string, required) — Status of the batch request
- `total_events` (integer, required) — Total number of events submitted in the batch
- `successful_events` (integer, required) — Number of events that were successfully processed
- `failed_events` (integer, required) — Number of events that failed to be processed
- `errors` (list of object, required) — List of errors for the failed events
  - `eventIndex` (list of integer, optional) — Index positions (0-based) of the events that caused the error
  - `message` (string, optional) — Description of the error

### 401 Unauthorized Error

bad request

- `code` (enum, required) — Error code displayed in case of a failure
  - Allowed values: `invalid_parameter`, `missing_parameter`, `out_of_range`, `campaign_processing`, `campaign_sent`, `document_not_found`, `not_enough_credits`, `permission_denied`, `duplicate_parameter`, `duplicate_request`, `method_not_allowed`, `unauthorized`, `account_under_validation`, `not_acceptable`, `bad_request`, `unprocessable_entity`, `Domain does not exist`, `Contact email not found`, `Attribute not found`, `Category id not found`, `Invalid parameters passed`, `Record(s) for identifier not found`, `Returned when query params are invalid`, `Returned when invalid data posted`, `Feed not found`, `Campaign ID not found`, `api-key not found`, `DMARC policy requires domain authentication`, `DNS records not properly configured`, `Invalid OTP code provided`, `OTP code has expired`, `Domain already exists in your account`, `The sum of all IP weights must equal 100`, `Authentication failed`, `Insufficient credits`, `Request already processed`
- `message` (string, required) — Readable message associated to the failure

## Examples

### Event_createBatchEvents_example

**Request**

```json
{
  "events": [
    {
      "event_name": "order_created",
      "identifiers": {}
    }
  ]
}
```

**Response**

```json
{
  "message": "Batch accepted. Valid events have been added to the processing queue.",
  "count": 7
}
```

**SDK Code**

```typescript Event_createBatchEvents_example
import { BrevoClient } from "@getbrevo/brevo";

async function main() {
    const client = new BrevoClient({
        apiKey: "YOUR_API_KEY_HERE",
    });
    await client.event.createBatchEvents({
        events: [
            {
                eventName: "order_created",
                identifiers: {},
            },
        ],
    });
}
main();

```

```python Event_createBatchEvents_example
from brevo import Brevo
from brevo.event import CreateBatchEventsRequestEventsItem, CreateBatchEventsRequestEventsItemIdentifiers

client = Brevo(
    api_key="YOUR_API_KEY_HERE",
)

client.event.create_batch_events(
    events=[
        CreateBatchEventsRequestEventsItem(
            event_name="order_created",
            identifiers=CreateBatchEventsRequestEventsItemIdentifiers(),
        )
    ],
)

```

```php Event_createBatchEvents_example
<?php

namespace Example;

use Brevo\Brevo;
use Brevo\Event\Requests\CreateBatchEventsRequest;
use Brevo\Event\Types\CreateBatchEventsRequestEventsItem;
use Brevo\Event\Types\CreateBatchEventsRequestEventsItemIdentifiers;

$client = new Brevo(
    apiKey: 'YOUR_API_KEY_HERE',
);
$client->event->createBatchEvents(
    new CreateBatchEventsRequest([
        'events' => [
            new CreateBatchEventsRequestEventsItem([
                'eventName' => 'order_created',
                'identifiers' => new CreateBatchEventsRequestEventsItemIdentifiers([]),
            ]),
        ],
    ]),
);

```

```go Event_createBatchEvents_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.brevo.com/v3/events/batch"

	payload := strings.NewReader("{\n  \"events\": [\n    {\n      \"event_name\": \"order_created\",\n      \"identifiers\": {}\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Event_createBatchEvents_example
require 'uri'
require 'net/http'

url = URI("https://api.brevo.com/v3/events/batch")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"events\": [\n    {\n      \"event_name\": \"order_created\",\n      \"identifiers\": {}\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Event_createBatchEvents_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.brevo.com/v3/events/batch")
  .header("api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"events\": [\n    {\n      \"event_name\": \"order_created\",\n      \"identifiers\": {}\n    }\n  ]\n}")
  .asString();
```

```csharp Event_createBatchEvents_example
using RestSharp;

var client = new RestClient("https://api.brevo.com/v3/events/batch");
var request = new RestRequest(Method.POST);
request.AddHeader("api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"events\": [\n    {\n      \"event_name\": \"order_created\",\n      \"identifiers\": {}\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Event_createBatchEvents_example
import Foundation

let headers = [
  "api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = ["events": [
    [
      "event_name": "order_created",
      "identifiers": []
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.brevo.com/v3/events/batch")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```

### Event_createBatchEvents_example

**Request**

```json
{
  "events": [
    {
      "event_name": "order_created",
      "identifiers": {}
    }
  ]
}
```

**Response**

```json
{
  "errors": [
    {
      "eventIndex": [
        2
      ],
      "message": "undefined event_name"
    }
  ],
  "failed_events": 1,
  "status": "partiallyQueued",
  "successful_events": 6,
  "total_events": 7
}
```

**SDK Code**

```typescript Event_createBatchEvents_example
import { BrevoClient } from "@getbrevo/brevo";

async function main() {
    const client = new BrevoClient({
        apiKey: "YOUR_API_KEY_HERE",
    });
    await client.event.createBatchEvents({
        events: [
            {
                eventName: "order_created",
                identifiers: {},
            },
        ],
    });
}
main();

```

```python Event_createBatchEvents_example
from brevo import Brevo
from brevo.event import CreateBatchEventsRequestEventsItem, CreateBatchEventsRequestEventsItemIdentifiers

client = Brevo(
    api_key="YOUR_API_KEY_HERE",
)

client.event.create_batch_events(
    events=[
        CreateBatchEventsRequestEventsItem(
            event_name="order_created",
            identifiers=CreateBatchEventsRequestEventsItemIdentifiers(),
        )
    ],
)

```

```php Event_createBatchEvents_example
<?php

namespace Example;

use Brevo\Brevo;
use Brevo\Event\Requests\CreateBatchEventsRequest;
use Brevo\Event\Types\CreateBatchEventsRequestEventsItem;
use Brevo\Event\Types\CreateBatchEventsRequestEventsItemIdentifiers;

$client = new Brevo(
    apiKey: 'YOUR_API_KEY_HERE',
);
$client->event->createBatchEvents(
    new CreateBatchEventsRequest([
        'events' => [
            new CreateBatchEventsRequestEventsItem([
                'eventName' => 'order_created',
                'identifiers' => new CreateBatchEventsRequestEventsItemIdentifiers([]),
            ]),
        ],
    ]),
);

```

```go Event_createBatchEvents_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.brevo.com/v3/events/batch"

	payload := strings.NewReader("{\n  \"events\": [\n    {\n      \"event_name\": \"order_created\",\n      \"identifiers\": {}\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("api-key", "<apiKey>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Event_createBatchEvents_example
require 'uri'
require 'net/http'

url = URI("https://api.brevo.com/v3/events/batch")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["api-key"] = '<apiKey>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"events\": [\n    {\n      \"event_name\": \"order_created\",\n      \"identifiers\": {}\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java Event_createBatchEvents_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.brevo.com/v3/events/batch")
  .header("api-key", "<apiKey>")
  .header("Content-Type", "application/json")
  .body("{\n  \"events\": [\n    {\n      \"event_name\": \"order_created\",\n      \"identifiers\": {}\n    }\n  ]\n}")
  .asString();
```

```csharp Event_createBatchEvents_example
using RestSharp;

var client = new RestClient("https://api.brevo.com/v3/events/batch");
var request = new RestRequest(Method.POST);
request.AddHeader("api-key", "<apiKey>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"events\": [\n    {\n      \"event_name\": \"order_created\",\n      \"identifiers\": {}\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Event_createBatchEvents_example
import Foundation

let headers = [
  "api-key": "<apiKey>",
  "Content-Type": "application/json"
]
let parameters = ["events": [
    [
      "event_name": "order_created",
      "identifiers": []
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.brevo.com/v3/events/batch")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```